/********************************************************************************************************
 * - PAN ID: 0x2176 for example										 								*
 * - Short address: 0x0000 ~ 0xFFFF changeable															*
 ********************************************************************************************************/

#include "include\include.h"
#include <avr/eeprom.h>

//-------------------------------------------------------------------------------------------------------
// Basic RF transmission and reception structures
//-------------------------------------------------------------------------------------------------------
BASIC_RF_RX_INFO rfRxInfo;
BASIC_RF_TX_INFO rfTxInfo;
BYTE pTxBuffer[BASIC_RF_MAX_PAYLOAD_SIZE];
BYTE pRxBuffer[BASIC_RF_MAX_PAYLOAD_SIZE];

//-------------------------------------------------------------------------------------------------------
// (7) ڰ ʿ信   ܺκ
//-------------------------------------------------------------------------------------------------------
//
//  ܺκ ߰
//

//-------------------------------------------------------------------------------------------------------
// (8) ڰ ʿ信   Լ ⿡ ϰų  .c Ͽ Ѵ.
//-------------------------------------------------------------------------------------------------------
//
//  Լ ߰
//
void UART1_PUTSTRING(char *str_add) //  Ʈ      
{
	UINT8 count_str=0,lenth=0;  
	lenth=strlen(str_add);	
		
	for (count_str=0;count_str<lenth;count_str++)
	{  					
		UART1_WAIT_AND_SEND(str_add[count_str]);
	}  
}

//-------------------------------------------------------------------------------------------------------
// (9)  Ȥ ̺κ Ÿ  ó Լ(ͷƮ  ƾ)
//-------------------------------------------------------------------------------------------------------
BASIC_RF_RX_INFO* basicRfReceivePacket(BASIC_RF_RX_INFO *pRRI) 
{
	unsigned char Command, tmp;
	unsigned int Fromaddr;

	// Ŷ   ּ
	Fromaddr = pRRI->srcAddr;

	//  ڵ
	Command = pRRI->pPayload[0];

	//  м
	switch(Command)
	{
//-------------------------------------------------------------------------------------------------------
// (9-1) ͷκ ̺갡 Ÿ  : ó  ٽ ͷ 
//-------------------------------------------------------------------------------------------------------
		case 0x01: // [1] Read RSSI
		{	
			pTxBuffer[0] = 0x11; // ̺갡 ͷ RSSI 
			pTxBuffer[1] = (pRRI->rssi);

			rfTxInfo.destAddr = Fromaddr;

			basicRfSendPacket(&rfTxInfo);

			break; // switch Ż
		} // case 0x01
		case 0x02: // [2] Read Light ADC
		{
			pTxBuffer[0] = 0x12; // ̺갡 ͷ  ADC 

			ADC_SAMPLE_SINGLE();
			ADC_GET_SAMPLE_8(tmp);

			pTxBuffer[1] = tmp;

			rfTxInfo.destAddr = Fromaddr;

			basicRfSendPacket(&rfTxInfo);
	
			break; // switch Ż
		} // case 0x02	
		case 0x03: // [3] Set Light ON/OFF
		{
			if (pRRI->pPayload[1] == 1)
				LIGHT_ON(); // Light ON
			else if (pRRI->pPayload[1] == 0) 			
				LIGHT_OFF(); // Light OFF

			pTxBuffer[0] = 0x13; // ̺갡 ͷ  ON/OFF  
			pTxBuffer[1] = pRRI->pPayload[1];

			rfTxInfo.destAddr = Fromaddr;

			basicRfSendPacket(&rfTxInfo);
	
			break; // switch Ż
		} // case 0x03	
//-------------------------------------------------------------------------------------------------------
// (9-2) ̺κ Ͱ Ÿ  :  ͹̳η 
//-------------------------------------------------------------------------------------------------------
		case 0x11: // ̺갡 ͷ RSSI 
		{	
			tmp = pRRI->pPayload[1] - 45;

			UART1_LINEFEED();
			UART1_LINEFEED();
			UART1_LINEFEED();
			UART1_LINEFEED();
			UART1_LINEFEED();

			UART1_PUTSTRING("> RSSI : ");
	
			if((tmp & 0x80) == 0)
			{
				UART1_WAIT_AND_SEND(tmp / 100 + 0x30);
				UART1_WAIT_AND_SEND(tmp / 10 - (tmp / 100) * 10 + 0x30);
				UART1_WAIT_AND_SEND((tmp - (tmp / 100) * 100) - ((tmp - (tmp / 100) * 100) / 10) * 10 + 0x30);	
			}
			else
			{
				tmp = ~(tmp - 1);
				UART1_WAIT_AND_SEND('-');
				UART1_WAIT_AND_SEND(tmp / 100 + 0x30);
				UART1_WAIT_AND_SEND(tmp / 10 - (tmp / 100) * 10 + 0x30);
				UART1_WAIT_AND_SEND((tmp - (tmp / 100) * 100) - ((tmp - (tmp / 100) * 100) / 10) * 10 + 0x30);	
			}

			UART1_PUTSTRING("[dBm]");
			UART1_LINEFEED();

			break; // switch Ż
		} // case 0x11
		case 0x12: // ̺갡 ͷ  ADC 
		{
			tmp = pRRI->pPayload[1];

			UART1_LINEFEED();
			UART1_LINEFEED();
			UART1_LINEFEED();
			UART1_LINEFEED();
			UART1_LINEFEED();

			UART1_PUTSTRING("> Light ADC : ");

			UART1_WAIT_AND_SEND(tmp / 100 + 0x30);
			UART1_WAIT_AND_SEND(tmp / 10 - (tmp / 100) * 10 + 0x30);
			UART1_WAIT_AND_SEND((tmp - (tmp / 100) * 100) - ((tmp - (tmp / 100) * 100) / 10) * 10 + 0x30);	

			UART1_LINEFEED();
	
			break; // switch Ż
		} // case 0x12	
		case 0x13: // ̺갡 ͷ  ON/OFF  
		{
			UART1_LINEFEED();
			UART1_LINEFEED();
			UART1_LINEFEED();
			UART1_LINEFEED();
			UART1_LINEFEED();

			UART1_PUTSTRING("> Light Status : ");
			if (pRRI->pPayload[1] == 1) UART1_PUTSTRING("ON");
			else if(pRRI->pPayload[1] == 0) UART1_PUTSTRING("OFF");
			else UART1_PUTSTRING("WRIGHT ERROR!!");

			UART1_LINEFEED();
	
			break; // switch Ż
		} // case 0x13		
		default: //  Ŷ 
		{
			break; // switch(Command) Ż
		}

	} // switch(Command)

	return pRRI; // Ŵ · 

} // basicRfReceivePacket

//-------------------------------------------------------------------------------------------------------
//	main Լ
//-------------------------------------------------------------------------------------------------------
int main(void) 
{
//-------------------------------------------------------------------------------------------------------
// (1) I/OƮ, , ATmega128 ġ  ֺġ ʱȭ
//-------------------------------------------------------------------------------------------------------
	unsigned int srcaddr;
	unsigned char i, x, eeprom[1];

	PORT_INIT();
	SPI_INIT();
	INIT_UART1(UART_BAUDRATE_115K2,UART_OPT_8_BITS_PER_CHAR); // UART1 ʱȭ(115.2 Kpbs)
	ENABLE_UART1();
	ADC_INIT();
	ADC_SET_CHANNEL(ADC_INPUT_2); // ADC2 
	ADC_ENABLE();

//-------------------------------------------------------------------------------------------------------
// (2) source address 
//-------------------------------------------------------------------------------------------------------
	*eeprom = 0; // EEPROM 0 source address  Ѵ
	srcaddr = (UINT16)eeprom_read_byte(eeprom); // EEPROM 0 о

//-------------------------------------------------------------------------------------------------------
// (3) ä  Pan ID 
//-------------------------------------------------------------------------------------------------------
	basicRfInit(&rfRxInfo, 26, 0x2176, srcaddr); // 26 ä , Pan ID = 0x2176( ..)

//-------------------------------------------------------------------------------------------------------
// (4) ۵Ÿ ũ 
//-------------------------------------------------------------------------------------------------------
	rfTxInfo.length = 10; // 10 Ʈ ( ..)

//-------------------------------------------------------------------------------------------------------
// ACK   
//-------------------------------------------------------------------------------------------------------
	rfTxInfo.ackRequest = TRUE;

	rfTxInfo.pPayload = pTxBuffer;
	rfRxInfo.pPayload = pRxBuffer;

//-------------------------------------------------------------------------------------------------------
// (5) ۵Ÿ ʱȭ
//-------------------------------------------------------------------------------------------------------
	for (unsigned char n = 0; n < 10; n++) 
	{
		pTxBuffer[n] = 0; // ۽  Ŭ
	}

	// Turn on RX mode
	basicRfReceiveOn();

//-------------------------------------------------------------------------------------------------------
// (6)  ƾ
//-------------------------------------------------------------------------------------------------------
	while(1) //  ݺ
	{
//-------------------------------------------------------------------------------------------------------
// (6-1) Ͱ ͹̳(PC) 
//-------------------------------------------------------------------------------------------------------

		// UART1 sends menu to Terminal
		UART1_LINEFEED();
		UART1_LINEFEED();
		UART1_LINEFEED();
		UART1_PUTSTRING("**********************<< ZBM Monitor V1.0 >>********************");
		UART1_LINEFEED();
		UART1_PUTSTRING("* [1] Read RSSI    [2] Read Light ADC     [3] Set Light ON/OFF *");
		UART1_LINEFEED();
		UART1_PUTSTRING("* [4] Read Address [5] Write Address                           *");
		UART1_LINEFEED();
		UART1_PUTSTRING("****************************************************************");
		UART1_LINEFEED();
		UART1_PUTSTRING("> Select Command Number : ");

		// UART1 receives Command Number from Terminal
		UART1_WAIT_AND_RECEIVE(x);

//-------------------------------------------------------------------------------------------------------
// (6-2) Ϳ ̺  Ÿ, destination address    ۽
//-------------------------------------------------------------------------------------------------------

		// Command Number м
		switch(x)
		{
			case 0x31: // [1] Read RSSI
			{	
				UART1_WAIT_AND_SEND(x);
				UART1_PUTSTRING(" Read RSSI");
				UART1_LINEFEED();
				pTxBuffer[0] = 0x01; // ̺  : Read RSSI
			
				// UART1 sends sub-menu to Terminal for destination address
				i = 2;
				UART1_PUTSTRING("> Type Destination Address[Decimal 00~99] : ");
				while(i)
				{
					UART1_WAIT_AND_RECEIVE(x);
					if((x >= 0x30) && (x <= 0x39))
					{
						UART1_WAIT_AND_SEND(x);
						if(i == 2) rfTxInfo.destAddr = (x - 0x30) * 10;
						else if(i == 1) rfTxInfo.destAddr += x - 0x30;
						i--;
					}
				} // while(i)

				// Master sends packet to Slave
				basicRfSendPacket(&rfTxInfo);
				halWait(50000);

				break; // switch Ż
			} // case 0x31
			case 0x32: // [2] Read Light ADC
			{	
				UART1_WAIT_AND_SEND(x);
				UART1_PUTSTRING(" Read Light ADC");
				UART1_LINEFEED();
				pTxBuffer[0] = 0x02; // ̺  : Read Light ADC

				// UART1 sends sub-menu to Terminal for destination address
				i = 2;
				UART1_PUTSTRING("> Type Destination Address[Decimal 00~99] : ");
				while(i)
				{
					UART1_WAIT_AND_RECEIVE(x);
					if((x >= 0x30) && (x <= 0x39))
					{
						UART1_WAIT_AND_SEND(x);
						if(i == 2) rfTxInfo.destAddr = (x - 0x30) * 10;
						else if(i == 1) rfTxInfo.destAddr += x - 0x30;
						i--;
					}
				} // while(i)

				// Master sends packet to Slave
				basicRfSendPacket(&rfTxInfo);
				halWait(50000);

				break; // switch Ż
			} // case 0x32
			case 0x33: // [3] Set Light ON/OFF
			{	
				UART1_WAIT_AND_SEND(x);
				UART1_PUTSTRING(" Set Light ON/OFF");
				UART1_LINEFEED();
				pTxBuffer[0] = 0x03; // ̺  : Set Light ON/OF

				// UART1 sends sub-menu to Terminal for destination address
				i = 2;
				UART1_PUTSTRING("> Type Destination Address[Decimal 00~99] : ");
				while(i)
				{
					UART1_WAIT_AND_RECEIVE(x);
					if((x >= 0x30) && (x <= 0x39))
					{
						UART1_WAIT_AND_SEND(x);
						if(i == 2) rfTxInfo.destAddr = (x - 0x30) * 10;
						else if(i == 1) rfTxInfo.destAddr += x - 0x30;
						i--;
					}
				} // while(i)

				// UART1 sends sub-menu to Terminal for light on or off
				UART1_LINEFEED();
				i = 1;
				UART1_PUTSTRING("> Select Number[0:off, 1:on] : ");
				while(i)
				{
					UART1_WAIT_AND_RECEIVE(x);
					if((x == 0x30) || (x == 0x31))
					{
						pTxBuffer[1] = x - 0x30;
						i--;
					}
				} // while(i)

				// Master sends packet to Slave
				basicRfSendPacket(&rfTxInfo);
				halWait(50000);

				break; // switch Ż
			} // case 0x33
			case 0x34: // [4] Read Address
			{	
				UART1_WAIT_AND_SEND(x);
				UART1_PUTSTRING(" Read Address");
				UART1_LINEFEED();
				UART1_LINEFEED();
				UART1_LINEFEED();
				UART1_LINEFEED();
				UART1_LINEFEED();

				UART1_PUTSTRING("> Address : ");

				// EEPROM 0 source address о Ѵ
				*eeprom = 0;
				UART1_WAIT_AND_SEND(eeprom_read_byte(eeprom)/10 + 0x30);
				UART1_WAIT_AND_SEND(eeprom_read_byte(eeprom)%10 + 0x30);
				UART1_LINEFEED();

				break; // switch Ż
			} // case 0x34
			case 0x35: // [5] Write Address
			{	
				UART1_WAIT_AND_SEND(x);
				UART1_PUTSTRING(" Write Address");
				UART1_LINEFEED();

				// UART1 sends sub-menu to Terminal
				i = 2;
				UART1_PUTSTRING("> Type Address[Decimal 00~99] : ");
				while(i)
				{
					UART1_WAIT_AND_RECEIVE(x);
					if((x >= 0x30) && (x <= 0x39))
					{
						UART1_WAIT_AND_SEND(x);
						if(i == 2) rfSettings.myAddr = (x - 0x30) * 10;
						else if(i == 1) rfSettings.myAddr += x - 0x30;
						i--;
					}
				} // while(i)

				// EEPROM 0 source address Ѵ
				*eeprom = 0;
				eeprom_write_byte (eeprom, (UINT8)rfSettings.myAddr);

				// Revise address on CC2420 tranceiver
				DISABLE_GLOBAL_INT();
    			FASTSPI_WRITE_RAM_LE(&rfSettings.myAddr, CC2420RAM_SHORTADDR, 2, i);
  				ENABLE_GLOBAL_INT();

				UART1_LINEFEED();
				UART1_PUTSTRING("> Address Writing Completed!");
				UART1_LINEFEED();

				break; // switch Ż
			} // case 0x35
			default: // Incorrect Number
			{
				UART1_LINEFEED();
				UART1_PUTSTRING("Incorrect! Select Number Again..");
				UART1_LINEFEED();
				break; // switch Ż
			}

		} // switch(x)

	} // while(1)

} // main()
